/********************************************************
*  J[OtBbNLCD(132131hbgjpCu
*     iZY-FGD1442701V1p)
*	lcd_Init();		// 
*	lcd_Clear();		// Sʏ
*	lcd_Pixel();		// 1hbg\
*	lcd_Char();		// ANK\
*	lcd_Str();		// ANK\
*	lcd_Line();		// `
*	lcd_Image();		// C[W}\
*********************************************************/
#include "p24FJ64GA002.h"
#include "colorlcd_lib24b.h"
#include "ASCII12dot.h"			// ANK@12x12hbg
#include "font.h"					// ANK@5x7hbg
/********************************
* R}hAf[^o͊֐ 
*********************************/
void lcd_cmd(unsigned char cmnd){
	unsigned int temp;

	temp = (unsigned int)cmnd;
	LATB = (temp << 8) | (LATB & 0x00FF); 
	LCD_CS = 0;				// CS Low
	LCD_DIO = 0;				// Command
	LCD_WR = 0;				// WR out
	Nop();
	LCD_WR = 1;
	LCD_DIO = 1;
	LCD_CS = 1;				// CS High
}
void lcd_data(unsigned char data){
	unsigned int temp;

	temp = (unsigned int)data;
	LATB = (temp << 8) | (LATB & 0x00FF);
	LCD_CS = 0;				// CS Low 
	LCD_DIO = 1;				// Data
	LCD_WR = 0;
	Nop();
	LCD_WR = 1;
	LCD_CS = 1;				// CS High
}

/****************************
* LCD֐  
*****************************/
void lcd_Init(void){
	LCD_CS = 1;				// CS High
	LCD_WR = 1;				// WR High
	LCD_RD = 1;				// RD High
	LCD_RST = 1;				// Reset off
	delay_ms(100);
	LCD_RST = 0;				
	delay_ms(100);			// Zbgo
	LCD_RST = 1;
	delay_ms(120);
	// Software reset
	lcd_cmd(SWRESET);
	delay_ms(50);

	lcd_cmd(SLPOUT);			// X[v
	delay_ms(200);			// EFCNAbv҂

	//
	lcd_cmd(VCOM4L);			//
	lcd_data(0x40);
	lcd_data(0x03);
	lcd_data(0x1A);
	//
	lcd_cmd(NVCTR1);
	lcd_data(0x60);
	//
	lcd_cmd(VMOFCTR);
	lcd_data(0x90);
	delay_ms(200);
	//
	lcd_cmd(FRMCTR1);			//Frame Rate in normal mode
	lcd_data(0x04);
	lcd_data(0x25);
	lcd_data(0x18);
	//
	lcd_cmd(FRMCTR2);			//Frame Rate in Idle mode
	lcd_data(0x04);
	lcd_data(0x25);
	lcd_data(0x18);
	//
	lcd_cmd(FRMCTR3);			//Frame Rate in Partial mode
	lcd_data(0x04);
	lcd_data(0x25);
	lcd_data(0x18);
	lcd_data(0x04);
	lcd_data(0x25);
	lcd_data(0x18);
	//
	lcd_cmd(INVCTR);			//Display Inversion normal
	lcd_data(0x03);
	//
	lcd_cmd(DISSET5);			//Gate overlap
	lcd_data(0x15);
	lcd_data(0x02);
	//
	lcd_data(PWCTR1);			//Power control
	lcd_data(0x02);			//VRH=4.7V IB=1uA
	lcd_data(0x70);
	//
	lcd_cmd(PWCTR2);			//Power control
	lcd_data(0x07);			//VGHH=6*VCI
	//
	lcd_cmd(PWCTR3);			//Power control Normal mode
	lcd_data(0x01);			//Small
	lcd_data(0x01);			//BCLK/1 BCLK/2
	//
	lcd_cmd(PWCTR4);			//Power control Idle mode
	lcd_data(0x02);			//Medium
	lcd_data(0x07);			//BCL/4 BCLK/16
	//
	lcd_cmd(PWCTR5);			//Power control Partial mode
	lcd_data(0x02);			//Medeum
	lcd_data(0x04);			//BCLK/2 BCLK/4
	//
	lcd_cmd(PWCTR6);			//Power control Partioal+Idle
	lcd_data(0x11);			//
	lcd_data(0x17);
	//
	lcd_cmd(VMCTR1);			//VCOM control
	lcd_data(0x3C);			//VCOMH=4.0
	lcd_data(0x4F);			//VCOML=-0.525
	//
	lcd_cmd(MADCTL);			//Memory Data Access H refresh
	lcd_data(0x08);
	//
	lcd_cmd(COLMOD);
	lcd_data(0x05);			// Color 16bit mode
	//
	lcd_cmd(GAMCTRP1);		//Gamma correction +pole
	lcd_data(0x06);
	lcd_data(0x0E);
	lcd_data(0x05);
	lcd_data(0x20);
	lcd_data(0x27);
	lcd_data(0x23);
	lcd_data(0x1C);
	lcd_data(0x21);
	lcd_data(0x20);
	lcd_data(0x1C);
	lcd_data(0x26);
	lcd_data(0x2F);
	lcd_data(0x00);
	lcd_data(0x03);
	lcd_data(0x00);
	lcd_data(0x24);
	//
	lcd_cmd(GAMCTRN1);		//Gamma correction -pole
	lcd_data(0x06);
	lcd_data(0x10);
	lcd_data(0x05);
	lcd_data(0x21);
	lcd_data(0x27);
	lcd_data(0x22);
	lcd_data(0x1C);
	lcd_data(0x21);
	lcd_data(0x1F);
	lcd_data(0x1D);
	lcd_data(0x27);
	lcd_data(0x2F);
	lcd_data(0x05);
	lcd_data(0x03);
	lcd_data(0x00);
	lcd_data(0x3F);
	//
	lcd_cmd(DISPON);			// \I
	delay_ms(200);
}
/***************************
* ʏ֐
* pFw肠
****************************/
void lcd_Clear(unsigned short Color){
	short i;

	lcd_cmd(CASET);				// RJnIAhXZbg
	lcd_data(0);
	lcd_data(0);
	lcd_data(0);
	lcd_data(ENDCOL);				// 130
	lcd_cmd(RASET);				// RawJnAIAhXZbg
	lcd_data(0);
	lcd_data(0);
	lcd_data(0);
	lcd_data(ENDPAGE);			// 128
	lcd_cmd(RAMWR);
	// 16bit color mode
	for(i=0; i<(ENDPAGE+1)*(ENDPAGE+1); i++){
		lcd_data(Color >> 8);
		lcd_data(Color);
	}
}
/***********************************
*  PsNZ\֐
*  W(0,0)-(128,128)  
***********************************/
void lcd_Pixel(short Xpos, short Ypos, unsigned short Color){
	/* if raw>131 or colum >132 then do nothing  */

	if((Xpos<=ENDCOL) && (Ypos<=ENDPAGE)){
		lcd_cmd(RASET);				// siRAW)AhXZbg
		lcd_data(0);	
		lcd_data(Ypos);
		lcd_data(0);
		lcd_data(Ypos);
		lcd_cmd(CASET);				// iCOLUM)AhXZbg
		lcd_data(0);	
		lcd_data(Xpos);
		lcd_data(0);
		lcd_data(Xpos);
		lcd_cmd(RAMWR);				// 1sNZ
		lcd_data((unsigned char)(Color >> 8));			// 16rbgJ[
		lcd_data((unsigned char)Color);
	}
}
/***************************
*  `֐
***************************/
#define	abs(a)	(((a)>0) ? (a) : -(a))
void lcd_Line(short x0, short y0, short x1, short y1, unsigned short Color)
{
	short steep, t;
	short deltax, deltay, error;
	short x, y;
	short ystep;
	
	y0=ENDPAGE-y0;						// YW]
	y1=ENDPAGE-y1;
	/// ̑傫ق߂
	steep = (abs(y1 - y0) > abs(x1 - x0));
	/// A̓ւ
	if(steep){
		t = x0; x0 = y0; y0 = t;
		t = x1; x1 = y1; y1 = t;
	}
	if(x0 > x1) {
		t = x0; x0 = x1; x1 = t;
		t = y0; y0 = y1; y1 = t;
	}
	deltax = x1 - x0;						// XvZ	
	deltay = abs(y1 - y0);
	error = 0;
	y = y0;
	/// XŃXebv̐؂ւ
	if(y0 < y1) ystep = 1; else ystep = -1;
	/// _ŕ`
	for(x=x0; x<x1; x++) {
		if(steep) lcd_Pixel(y,x,Color); else lcd_Pixel(x,y,Color);
		error += deltay;
		if((error << 1) >= deltax) {
			y += ystep;
			error -= deltax;
		}
	}
}
/*****************************************
*  ANK\֐ 8x8hbg
*  128/8=16/s@132/8=16s
*  (0, 0) - (15, 15)͈̔
******************************************/
/*
void lcd_Char(char line, char colum, unsigned char letter, unsigned short Color1, unsigned short Color2){
	unsigned char j, i, Mask;

	if((colum < 16) && (line < 16)){		// ͈̓`FbN
		for(j=0; j<5; j++){				// 5hbg
			Mask = 0x80;					// ʃrbg\
			for(i=0; i<8; i++){			// c1C\
				if((Font[letter-0x20][j] & Mask) != 0)
					lcd_Pixel(colum*8+j+3, (line+1)*8-i, Color1);
				else
					lcd_Pixel( colum*8+j+3, (line+1)*8-i, Color2); //wiF	
				Mask = Mask >> 1;
			}
		}
		for(j=5; j<8; j++){
			lcd_Pixel(colum*8+j+3, (line+1)*8-i, Color2); //wiF
		}
	}
}
*/

/*****************************************
*  ANK\֐ 12x12hbg
*  320/12=26/s@240/14=17s
*  (0, 0) - (29, 16)͈̔
******************************************/
void lcd_Char(char colum, char line, unsigned char letter, unsigned short Color1, unsigned short Color2){
	unsigned char j, i, Mask;

	if((colum < XChar) && (line < YLine)){		// ͈̓`FbN
		// ANK\ó@3oCg2C6JԂ
		for(j=0; j<6; j++){
			// 8hbgA̕\
			Mask = 0x80;
			for(i=0; i<8; i++){
				// PCڑO8hbg\
				if((ANKFont[letter][j*3] & Mask) != 0)
					lcd_Pixel(colum*12+i, line*14+j*2, Color1);
				else
					lcd_Pixel(colum*12+i, line*14+j*2, Color2); 	//wiF
				// 2Cڌ㔼8hbg\
				if((ANKFont[letter][j*3+2] & Mask) != 0)
					lcd_Pixel(colum*12+i+4, line*14+j*2+1, Color1);
				else
					lcd_Pixel(colum*12+i+4, line*14+j*2+1, Color2); 	//wiF
				Mask = Mask >> 1;
			}
			// 4hbg\
			Mask = 0x80;
			// 1Cڌ㔼4hbg\
			for(i=0; i<4; i++){
				if((ANKFont[letter][j*3+1] & Mask) != 0)
					lcd_Pixel(colum*12+i+8, line*14+j*2, Color1);
				else
					lcd_Pixel(colum*12+i+8, line*14+j*2, Color2);	 //wiF
				Mask = Mask >> 1;
			}
			// 2CڑO4hbg\
			for(i=4; i<8; i++){
				if((ANKFont[letter][j*3+1] & Mask) != 0)
					lcd_Pixel(colum*12+i-4, line*14+j*2+1, Color1);
				else
					lcd_Pixel(colum*12+i-4, line*14+j*2+1, Color2); 	//wiF
				Mask = Mask >> 1;
			}							
		}
	}
}
/******************************
*   `֐
*   1616sŎw
******************************/
void lcd_Str(char colum, char line, char *s, unsigned short Color1, unsigned short Color2)
{
    	while (*s){
		lcd_Char(colum++, line, *s++, Color1, Color2);
		if(colum >= XChar){
			line++;
			colum = 0;
			if(line >= YLine)
				line = 0;
		}
	}
}

/*********************************************************
* C[W\֐
*@ f[^͏c8C1oCgŊi[Ă
*   128~128/8=2koCg/
*   OtBbNF(Color1)ƔwiF(Color2)w
**********************************************************/
void lcd_Image(char line, const unsigned char *ptr, unsigned short Color1, unsigned Color2)
{
	unsigned char Mask;
	short i, vline, colum;


	for(vline=line; vline<line+8; vline++){			// Ŝ8s~8=64C
		for(colum=0; colum<128; colum++){			// 128hbgƂ
			Mask = 0x01;							// ʃrbg㑤
			for(i=0; i<8; i++){					// 1oCg
				if(*ptr & Mask)					// rbg`FbN
					lcd_Pixel(colum, vline*8+i, Color1);
				else
					lcd_Pixel(colum,  vline*8+i,Color2);					
				Mask = Mask << 1;					// rbgʒuVtg
			} 
			ptr++;								// ̃f[^
		}
	}
}

/**********************************
*  [vx֐@usecP
**********************************/
void delay_us(unsigned short usec){
	unsigned short i, Max;
	
	Max = usec * Fosc/14;
	for(i=0; i<Max; i++)
	{	}
}
/**********************************
*  [vx֐@msecP
**********************************/		 
void delay_ms(unsigned short msec){
	unsigned short i;
	
	for(i=0; i<msec; i++)
		delay_us(1000);
}
