/*********************************************************************
*  FGD1442701 J[OtBbNLCDeXg
*@132x131hbg@16rbgJ[
*@vWFNgF ColorLCD2
*  PIC24Fœ쎎
*********************************************************************/
#include "p24FJ64GA002.h"
#include "colorlcd_lib24b.h"
#include "imagedata.h"
#include "math.h"

// RtBM[Vݒ
_CONFIG1( JTAGEN_OFF & GCP_OFF & GWRP_OFF & BKBUG_OFF & COE_OFF & FWDTEN_OFF & ICS_PGx1 ) 
_CONFIG2( IESO_OFF & FNOSC_FRCPLL & FCKSM_CSDCMD & OSCIOFNC_OFF & IOL1WAY_ON & I2C1SEL_PRI & POSCMOD_NONE)

/* O[oϐ`  */
short i,j, k, l, SW, Num, Flag, temp, Size, XOffset, YOffset;
unsigned char ASCII;
short Upper, Lower;
char Line, Colum;
/* Prototyping  */
void D2Graph(short Hight);

/*********** C[` ***************/
int main(void)
{
    	// Setup PortA IOs as digital
    	AD1PCFG = 0xffff;
	CLKDIV = 0;						// Clock devider off
	// Setup PORT In/Out
	TRISA = 0xFFEC;					// RA4 output
	TRISB = 0x0000;					// all output
	//I/Oݒ
	AD1PCFG = 0xFFFE;					// fW^
	// t\̏ƊJnbZ[W\
	lcd_Init();
	lcd_Clear(BLACK);
	SW = 6;
	/****** C [v  *******/
 	while(1){
		LATAbits.LATA0 ^= 1;
		SW++;
		if(SW==7)
			SW = 0;
		/* XCb`̒lɂe֕ */
		switch(SW){
			/****** ANK\ *********/
			case 0:											// \eXg				
				lcd_Clear(BLACK);								// NA
				for(j=0; j<3; j++){							// ASCIIS\@XChar/s
					for(i=0; i<XChar; i++){
						ASCII = j*XChar+i+0x20;				// XCharŌJԂ
						lcd_Char(i, j, ASCII, WHITE, BLACK);	// \
					}
				}
				for(j=3; j<6; j++){							// ASCIIS\@XChar/s
					for(i=0; i<XChar; i++){
						ASCII = j*XChar+i+0x20;				// XCharŌJԂ
						lcd_Char(i, j, ASCII, GREEN, BLACK);	// \
					}
				}
				for(j=6; j<YLine; j++){						// ASCIIS\@XChar/s
					for(i=0; i<XChar; i++){
						ASCII = j*XChar+i+0x20;				// XCharŌJԂ
						lcd_Char(i, j, ASCII, YELLOW, BLACK);	// \
					}
				}
				delay_ms(3000);								// 1.5b҂
				break;
			/******** \eXg@*******/
			case 1:											// ̕\eXg
				lcd_Clear(BLACK);
				delay_ms(100);				
				lcd_Str(0, 0, "Hello World!!", RED, BLACK);
				lcd_Str(0, 2, "Graphic LCD Test", GREEN, BLACK);
				lcd_Str(0, 4, "This is Yellow. ", YELLOW, BLACK);
				lcd_Str(0, 6, "This is Cyan.   ", CYAN, BLACK);
//				lcd_Str(0, 8, "This is Magenta.", MAGENTA, BLACK);
//				lcd_Str(0, 10, "This is Blue and over 30 character case.", BLUE, BLACK); 
//				lcd_Str(0, 12, "This is WHITE.", WHITE, BLACK);
//				lcd_Str(0, 14, "This is PINK.", PINK, BLACK);
				lcd_Str(0, YLine-1, "This is ORANGE.", ORANGE, BLACK);
				delay_ms(3000);
				break;
			/***** `eXgi΂ߒ) *********/			
			case 2:											/* sNZ\@\ */							
				lcd_Clear(BLACK);								// SNA
				for(i=0; i<=ENDPAGE; i++){						// ΂ߒ̕\
					lcd_Pixel(i,i,RED);
				}
				delay_ms(2000);								// 2b҂
				lcd_Clear(WHITE);								// S
				for(i=0; i<=ENDCOL; i++){						// ΂ߒ\
					lcd_Pixel(i, i, BLUE);
				}
				delay_ms(1500);								// 1.5b҂
				break;
			/************ {bNX\@**************/
			case 3:											// `eXg
				lcd_Clear(BLACK);
				if(ENDPAGE < ENDCOL){
					Size = ENDPAGE;
					XOffset = (ENDCOL - ENDPAGE) / 2;
					YOffset = 0;
				}
				else{
					Size = ENDCOL;
					XOffset = 0;
					YOffset = (ENDPAGE - ENDCOL) / 2;
				}		
				for(j=0; j<Size/2; j+=4){						// {bNX\
					if(Flag){
						Flag = 0;
						// ɏȃ{bNX
						lcd_Line(j+XOffset,j+YOffset, Size-j+XOffset, j+YOffset, RED);
						lcd_Line(j+XOffset,j+YOffset, j+XOffset, Size-j+YOffset, GREEN);
						lcd_Line(Size-j+XOffset,Size-j+YOffset, Size-j+XOffset,j+YOffset, RED);
						lcd_Line(Size-j+XOffset,Size-j+YOffset, j+XOffset,Size-j+YOffset, GREEN);
					}
					else{
						Flag = 1;
						// ɏȃ{bNX
						lcd_Line(j+XOffset,j+YOffset, Size-j+XOffset, j+YOffset, YELLOW);
						lcd_Line(j+XOffset,j+YOffset, j+XOffset, Size-j+YOffset, BLUE);
						lcd_Line(Size-j+XOffset,Size-j+YOffset, Size-j+XOffset,j+YOffset, YELLOW);
						lcd_Line(Size-j+XOffset,Size-j+YOffset, j+XOffset,Size-j+YOffset, BLUE);
					}
				}
				delay_ms(3000);
				break;
			/**************** Ȑ`i2Ot\j****************/
			case 4:
				for(i=0; i<8; i++){						// Ȑ`
					lcd_Clear(BLACK);							
					lcd_Str(0, 0, "Graphic Display", BLUE, BLACK);
					D2Graph(20*i);						//ȖʃOt\
					delay_ms(2000);
				}
				break;
			/******* C[WOtBbN\ ********/
			case 5:										// C[W̕\eXg
				lcd_Clear(BLACK);
				lcd_Image(0, Header1, MAGENTA, BLACK);
				lcd_Image(8, Header2, CYAN, BLACK);
				delay_ms(3000);
				break;
			/******** SʃNAieFNA) ***********/
			case 6:  									// SʃNÃeXg 	
				lcd_Clear(WHITE);							// eF̕\
				delay_ms(1500);
				lcd_Clear(RED);
				delay_ms(500);
				lcd_Clear(GREEN);
				delay_ms(500);
				lcd_Clear(BLUE);
				delay_ms(500);
				lcd_Clear(CYAN);
				delay_ms(500);
				lcd_Clear(MAGENTA);
				delay_ms(500);
				lcd_Clear(YELLOW);
				delay_ms(500);
				lcd_Clear(BROWN);
				delay_ms(500);
				lcd_Clear(ORANGE);
				delay_ms(500);
				lcd_Clear(PINK);
				delay_ms(500);
				lcd_Clear(BLACK);
				delay_ms(1000);
				break;
			/**** default **********/		
			default: delay_ms(300);
				 break;
		}
    }
}

/*********************************************
*  2̃Ot`֐
*   z(x,y) = 1/(1+SQRT(x2+y2))*COS(SQRT(x2+y2))
*    (-3*PI< x,y < 3*PI͈̔)
*   z̍őlPOTŕύX
**********************************************/
/*@O[o萔 */
#define X0	5
#define Y0	20
#define PI	3.141592654f
#define NODES	30
#define SIDE	4
/*** `֐ **/
void D2Graph(short Hight) {
	short i, j, px, py,x, y, z;
	float zf, xf, yf, sf;
	struct{
		short x;
		short y;
	} edge[NODES], prev;

	lcd_Line(X0, 3, X0, 120 ,GREEN);				// z axis
	lcd_Line(X0-3, Y0, 127, Y0, GREEN);				// x axis
	lcd_Line(X0, Y0-2, X0+64, Y0+64, GREEN);			// y axis
	for(j=0; j<NODES; j++) {
		edge[j].x = X0 + j*SIDE/2;
		edge[j].y = Y0 + j*SIDE/2;
	}
	for(i=0; i<NODES; i++) {
		x = i *SIDE;
		xf = (6 * PI / 200) *(float)(x-100);
		prev.y = Y0;
		prev.x = X0 + x;
		for(j=0; j<NODES; j++) {
			y = j * SIDE;
			yf = (6 * PI /200) * (float)(y -100);
			sf = sqrt(xf * xf + yf * yf);
			zf = 1/(1+sf) * cos(sf);
			z = zf * Hight;
			px = X0 + x + y/2;
			py = Y0 + z + y/2;
			lcd_Pixel(px, 127-py, 1);
			lcd_Line(px, py, prev.x, prev.y, RED);
			lcd_Line(px, py, edge[j].x, edge[j].y, RED);
			prev.x = px;
			prev.y = py;
			edge[j].x = px;
			edge[j].y = py;
		}
	}
}


